//*******************************************************
//@ohbPQkePWQQ mdbV[OCgpAŃGARpA h^nf[^erpRvOiVAԊOʐMɂj
//   PIC12LF1822 Remote Control for NEC ceiling light, Toshiba Aircon & I/O-TV( with Serial IR Tranciever)
//
//  file name: main.c
//
//@@EŃerpɕύX鎞
//@@@傫ȃ^NgXCb`irQFb|tjƕʂ̃^NgXCb`irPFojꂽ
//@@@DSM(Digital Signal Modurator)ŕΏdVAMo͂
//@@@ZbgXCb`𕁒ʂ̃XCb`irRFb|cjƂA
//@@@kdcĂq`SirSFu|tjƂq`TirTFu|cj͂ɂăXCb`ǉ
//@@
//@@Eh^nf[^erƂmdbV[OCgpɂ鎞
//@@@ԊOMf[^ύXB
//@@
//@@EŃGARpɂ鎞
//@@@ԊOMf[^ύXB
//@@
//@@
//
//   MPLAB IDE v8.84  HiTEC C
//   
//   VAԊOʐMvOɏCB
//
//   X[v̏d͖W`i12LF1822 gKvLj
//
//  2017/10/21  New (TAB4) Taishi
//  2021/01/02  Modify from remote control for nixie by Taishi
//  2021/10/16  Modify from remote control for IOTV & NEC Ceiling Light by Taishi
//  2022/03/01  Modify from remote control for NEC ceiling light, Toshiba Aircon & I/O-TV by Taishi
//*******************************************************

#include	<htc.h>

#include	"12lf1822_light_tair_iotv.h"

// CONFIG for 12LF1822

__CONFIG (	FCMEN_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	IESO_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	CLKOUTEN_OFF		//	1(OFF) = CLKOUT@\𖳌ɂBCLKOUT sI/O Ƃċ@\
		&	BOREN_ON			//	11 = BOR(uEAEgZbg)Lɂ
		&	CPD_OFF				//	1(OFF) = f[^̃R[hی𖳌ɂ
		&	CP_OFF				//	1(OFF) = vÕR[hی𖳌ɂ
		&	MCLRE_OFF			//	0(OFF) = MCLR/VPP s͂q`RƂċ@\B<-- TV Remote
		&	PWRTE_ON			//	0 = PWRT(p[Abv^C}[)Lɂ
		&	WDTE_OFF			//	00 = WDT(EHb`hbO^C}[)𖳌ɂ
		&	FOSC_INTOSC			//	100 = INTOSCIV[^:CLKIN sI/O Ƃċ@\
);

								//	fobO@\͏ݑuɔCij

__CONFIG (	LVP_OFF				//	0(OFF)=vO~OMCLR ɍdKv
		&	BORV_LO				//	1 = uEAEgZbgd(Vbor)̃gbv|Cgɐݒ肷
		&	STVREN_ON			//	1(ON) = X^bÑI[o[t[܂̓A_[t[ɂăZbg𔭐
		&	PLLEN_ON			//	1 = 4xPLL Lɂ
		&	WRT_OFF				//	11 = ݕیOFF ɂ
);


//*******************************************************
//************** TV remote Conrol ***********************
//*******************************************************

//*******************************************************
// Transmit Data (NEC format)
//*******************************************************
char	str_nec_form[5][10]={											
//          Data Form     NofData 1'st 2'nd 3'rd 4'th 5'th 6'th 7'th 8'th
			{NEC_FORMAT,  0x04,   0x41,0xb6,0xd5,0x2a,0x00,0x00,0x00,0x00},		// S1: NEC Ceiling Light ON/OFF
			{TAIR_FORMAT, 0x06,   0xb2,0x4d,0xbf,0x40,0x0c,0xf3,0x00,0x00},		// S2: T-aircon 17deg ON
			{TAIR_FORMAT, 0x06,   0xb2,0x4d,0x7b,0x84,0xe0,0x1f,0x00,0x00},		// S3: Toshiba Aircon 17deg OFF
			{NEC_FORMAT,  0x05,   0x01,0x17,0x48,0x00,0x4c,0x00,0x00,0x00},		// S4: I/O-TV Power
			{NEC_FORMAT,  0x05,   0x01,0x17,0x48,0x0a,0xce,0x00,0x00,0x00},		// S5: I/O-TV Ch Down
		};


//*******************************************************
// Transmit Leader Data (NEC)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_leader(void)
{
	MDBIT = 0;						// 38kHz ON
	__delay_us(V_LEADER_ON_NEC);	// Wait;
	MDBIT = 1;						// 38kHz OFF

	__delay_us(V_LEADER_OFF_NEC);	// Wait;
}

//*******************************************************
// Transmit Trailer Data (NEC)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_trailer(void)
{
	MDBIT = 0;						// 38kHz ON
	__delay_us(V_TRAILER_ON_NEC);	// Wait;
	MDBIT = 1;						// 38kHz OFF

	__delay_us(V_TRAILER_OFF_NEC);	// Wait;

}

//*******************************************************
// Transmit Repeat Data (NEC)
//*******************************************************
void	tx_nec_repeat(void)
{
	tx_nec_leader();				// Transmit Leader Data
	tx_nec_trailer();				// Transmit Trailer Data
	__delay_us(V_REPEAT_WAIT_NEC);	// Wait;
}

//*******************************************************
// Transmit NEC Form 1Byte
//  arg c : Transmit Data(1byte)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_form_char(char c)
{
	unsigned char	i;
	unsigned char	b=0x80;

	for(i=0;i<8;i++,b >>= 1){			// Bit7 --> Bit0 Transmit
		MDBIT = 0;						// 38kHz ON
		__delay_us(V_ZERO_ON_NEC);		// Wait;
		MDBIT = 1;						// 38kHz OFF
		if((c & b)==0){					// Bit : 0
			__delay_us(V_ZERO_OFF_NEC);	// Wait;
		}else{							// Bit : 1
			__delay_us(V_ONE_OFF_NEC);	// Wait;
		}
	}

}

//*******************************************************
// Transmit NEC format (New)
//   arg sFstring pointer ([0]=NofData [1]...=Data)
//*******************************************************
void	tx_new_nec_form_str(char *s)
{
	char	i;
	char	n;

	tx_nec_leader();			// Transmit Leader Data

	n = *s;
	s++;
	for(i=0;i<n;i++){
		tx_nec_form_char(*s);	// Transmit 1Byte
		s++;
	}

	tx_nec_trailer();			// Transmit Trailer Data

}

//*******************************************************
// proc Switch ON (NEC Format)
//   arg n: Switch No.(1,2,3,4 and 5j
//*******************************************************
void	proc_nec_switch_on(unsigned char n)
{

	if((n == 1) || (n == 2) || (n == 3) || (n == 4) || (n == 5)){
		MDEN = 1;						// DSM Module Validity

		tx_new_nec_form_str(&str_nec_form[n-1][1]);	// Transmit Data(String)

		while(1){
			if(n == 1){					// Switch No = 1
				if(RA1 != 0){			// S1:high
					__delay_ms(20);		// 20ms Wait
					if(RA1 != 0){		// S1:high Check Twice
						break;
					}
				}
			}else if(n == 2){			// Switch No = 2
				if(RA2 != 0){			// S2:high
					__delay_ms(20);		// 20ms Waiy
					if(RA2 != 0){		// S2:high Check Twice
						break;
					}
				}
			}else if(n == 3){			// Switch No = 3
				if(RA3 != 0){			// S3:high
					__delay_ms(20);		// 20ms Waiy
					if(RA3 != 0){		// S3:high Check Twice
						break;
					}
				}
			}else if(n == 4){			// Switch No = 4
				if(RA4 != 0){			// S4:high
					__delay_ms(20);		// 20ms Waiy
					if(RA4 != 0){		// S4:high Check Twice
						break;
					}
				}
			}else{						// Switch No = 5
				if(RA5 != 0){			// S5:high
					__delay_ms(20);		// 20ms Waiy
					if(RA5 != 0){		// S5:high Check Twice
						break;
					}
				}
			}
			tx_nec_repeat();			// Transmit Repeat Data
		}

		MDEN = 0;						// DSM Module Invalidity

	}
}

//*******************************************************
// Transmit Leader Data (Toshiba Aircon)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_tair_leader(void)
{
	MDBIT = 0;						// 38kHz ON
	__delay_us(V_LEADER_ON_TAIR);	// Wait;
	MDBIT = 1;						// 38kHz OFF

	__delay_us(V_LEADER_OFF_TAIR);	// Wait;
}

//*******************************************************
// Transmit Trailer Data (Toshiba Aircon)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_tair_trailer(void)
{
	MDBIT = 0;						// 38kHz ON
	__delay_us(V_TRAILER_ON_TAIR);	// Wait;
	MDBIT = 1;						// 38kHz OFF

	__delay_us(V_TRAILER_OFF_TAIR);	// Wait;

}

//*******************************************************
// Transmit Toshiba Aircon Form 1Byte
//  arg c : Transmit Data(1byte)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_tair_form_char(char c)
{
	unsigned char	i;
	unsigned char	b=0x80;

	for(i=0;i<8;i++,b >>= 1){				// Bit7 --> Bit0 Transmit
		MDBIT = 0;							// 38kHz ON
		__delay_us(V_ZERO_ON_TAIR);			// Wait;
		MDBIT = 1;							// 38kHz OFF
		if((c & b)==0){						// Bit : 0
			__delay_us(V_ZERO_OFF_TAIR);	// Wait;
		}else{								// Bit : 1
			__delay_us(V_ONE_OFF_TAIR);		// Wait;
		}
	}

}

//*******************************************************
// Transmit Toshina Aircon format
//   arg sFstring pointer ([0]=NofData [1]...=Data)
//*******************************************************
void	tx_new_tair_form_str(char *s)
{
	char	i;
	char	n;
	char	*ls;

	ls = s;						// Data Pointer Save


// ------ 1'st Transmit ------
	tx_tair_leader();			// Transmit Leader Data

	s = ls;						// Data Pointer Loard
	n = *s;
	s++;
	for(i=0;i<n;i++){
		tx_tair_form_char(*s);	// Transmit 1Byte
		s++;
	}

	tx_tair_trailer();			// Transmit Trailer Data


// ------ 2'nd Transmit ------
	tx_tair_leader();			// Transmit Leader Data

	s = ls;						// Data Pointer Loard
	n = *s;
	s++;
	for(i=0;i<n;i++){
		tx_tair_form_char(*s);	// Transmit 1Byte
		s++;
	}

	tx_tair_trailer();			// Transmit Trailer Data

}

//*******************************************************
// proc Switch ON (Toshiba Aircon Format)
//   arg n: Switch No.(1,2,3,4 and 5j
//*******************************************************
void	proc_tair_switch_on(unsigned char n)
{
	MDEN = 1;						// DSM Module Validity
	tx_new_tair_form_str(&str_nec_form[n-1][1]);	// Transmit Data(String)
	MDEN = 0;						// DSM Module Invalidity

	while(1){
		if(n == 1){					// Switch No = 1
			if(RA1 != 0){			// S1:high
				__delay_ms(20);		// 20ms Wait
				if(RA1 != 0){		// S1:high Check Twice
					break;
				}
			}
		}else if(n == 2){			// Switch No = 2
			if(RA2 != 0){			// S2:high
				__delay_ms(20);		// 20ms Waiy
				if(RA2 != 0){		// S2:high Check Twice
					break;
				}
			}
		}else if(n == 3){			// Switch No = 3
			if(RA3 != 0){			// S3:high
				__delay_ms(20);		// 20ms Waiy
				if(RA3 != 0){		// S3:high Check Twice
					break;
				}
			}
		}else if(n == 4){			// Switch No = 4
			if(RA4 != 0){			// S4:high
				__delay_ms(20);		// 20ms Waiy
				if(RA4 != 0){		// S4:high Check Twice
					break;
				}
			}
		}else{						// Switch No = 5
			if(RA5 != 0){			// S5:high
				__delay_ms(20);		// 20ms Waiy
				if(RA5 != 0){		// S5:high Check Twice
					break;
				}
			}
		}
	}

}

//*******************************************************
// proc Switch ON (DENON Format)
//   arg n: Switch No.(1,2,3,4 and 5j
//*******************************************************
void	proc_denon_switch_on(unsigned char n)
{
// Not Use
}


//*******************************************************
// proc Switch ON
//   arg n: Switch No.(1,2,3,4 and 5j
//*******************************************************
void	proc_switch_on(unsigned char n)
{
	if((n == 1) || (n == 2) || (n == 3) || (n == 4) || (n == 5)){

		if(str_nec_form[n-1][0] == NEC_FORMAT){				// NEC Format Transmit Data(String)
			proc_nec_switch_on(n);							// NEC Format Transmit Data(String)
		}else if(str_nec_form[n-1][0] == TAIR_FORMAT){		// Toshiba Aircon Format Transmit Data(String)
			proc_tair_switch_on(n);							// Toshiba Aircon Transmit Data(String)
		}else if(str_nec_form[n-1][0] == DENON_FORMAT){		// DENON Format Transmit Data(String)
			proc_denon_switch_on(n);						// DENON Transmit Data(String)
		}else{												// Other
			proc_nec_switch_on(n);							// NEC Format Transmit Data(String)
		}

	}
}

//*******************************************************
// main
//*******************************************************
void	main(void)
{
	unsigned char	i;
	unsigned char	j;

	di();						//	荞݋֎~

//				76543210
	OSCCON	= 0b01110000;		//	NbNWlg@c@okkHLȂ̂ŎRQlg
	OPTION_REG &= 0b01111111;	// Ŝ̃vAbvLɂ

//				76543210		//  |[g`
	ANSELA	= 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTA	= 0b00000000;		//	o̓f[^ݒ(0)
	TRISA	= 0b00111110;		//	o͕ݒ(RA5,4,3,2,1:)
	WPUA	= 0b00111110;		//	vAbvݒ(RA5,4,3,2,1:vAbvL)

	for(i=0;i<10;i++){
		PORTA ^= 0x01;			//  Infrared  LED ON or OFF
		__delay_ms(500);		//	TOOҋ@;
	}

	// Timer1 Init. gȂ
	T1CON  = 0b00000000;		// Fosc/4, prescaler 1:1, timer1osc:dis, sync Fosc, ~
	T1GCON = 0b00000000;		// Timer1 Not Link Gate
	TMR1H  = 0;					// Uper Reg
	TMR1L  = 0;					// Lower Reg

	// DSM(Digital Signal Modurator) ̐ݒ@inm^neeL[COj

	//  bboPgɂāAlcahsMi\tgjϒMƂ
	//    o͔]ĂȂA̔guŁ@k̔gbboPiovljȂ̂Ł@
	//    ϒM ̎͂kóAk͕̎ϒMiovljoB
	MDCON  = 0b01000001;		// W[Aso͂͗LAX[[gAo͔]ȂAlcahs͔gggp
	MDSRC  = 0b10000000;		// W[^M̏o̓sFAW[^MFMDBIT
	MDCARH = 0b10000000;		// Ig̏o̓sFAggFVss
	MDCARL = 0b10000100;		// Ig̏o̓sFAkgFCCP1(PWM)


	// 38KHz ̔g`o  26.32uSAFosc/4(8MHz) ŃJEg 210 ɂȂ
	//  ^C}[QJEg^C}[ɂȂ
	T2CON= 0b00000000;			// |XgXP[1:1A܂~AvXP[P
	TMR2    = 0;				// ^C}[l[NAilj
	PR2 = 210;					// 38kHz

	// CCP1 Init.
	CCPR1L = PR2/2;				// 50:50 PWMf[eBig̎ԁj
	CCP1CON = 0b00001100;		// PWM[hVOo
	TMR2ON  = 1;				// ^C}[QX^[g

	MDMSODIS = 0;				// MSD X^[g

// Remote Control
	while(1){
		if(RA5 == 0){					// S5:Low
			__delay_ms(20);				//	QOҋ@;
			if(RA5 == 0){				// S5:Low Qx@{Low
				proc_switch_on(5);		// Proc Switch-5 ON
			}
		}

		if(RA4 == 0){					// S4:Low
			__delay_ms(20);				//	QOҋ@;
			if(RA4 == 0){				// S4:Low Qx@{Low
				proc_switch_on(4);		//Proc Switch-4 ON
			}
		}

		if(RA3 == 0){					// S3:Low
			__delay_ms(20);				//	QOҋ@;
			if(RA3 == 0){				// S3:Low Qx@{Low
				proc_switch_on(3);		//Proc Switch-3 ON
			}
		}

		if(RA2 == 0){					// S2:Low
			__delay_ms(20);				//	QOҋ@;
			if(RA2 == 0){				// S2:Low Qx@{Low
				proc_switch_on(2);		//Proc Switch-2 ON 
			}
		}

		if(RA1 == 0){					// S1:Low
			__delay_ms(20);				//	QOҋ@;
			if(RA1 == 0){				// S1:Low Qx@{Low
				proc_switch_on(1);		//Proc Switch-1 ON 
			}
		}

		IOCAP = 0x00;					// オGbWԕω荞݃WX^FNAiׂĖj
		IOCAN1 = 1;						// q`PGbWԕω荞݁FL
		IOCAN2 = 1;						// q`QGbWԕω荞݁FL
		IOCAN3 = 1;						// q`RGbWԕω荞݁FL
		IOCAN4 = 1;						// q`SGbWԕω荞݁FL
		IOCAN5 = 1;						// q`TGbWԕω荞݁FL
		IOCAF = 0x00;					// ԕω荞݃tOWX^ otONA
		IOCIE = 1;						// ԕω荞݁FL
		PEIE = 1;						// Ӌ@\荞݁FL

		SLEEP();						// 啶ɒӁII
		NOP();							// 啶ɒӁII

	}

}
